 ; Peripherals definition of addresses:
 ; Same as in ST RM0008 Manual
 ; I/O ports for the whole family
 ;
 ; Low 8 control
     GPIOA_CRL	     =	0x40010800
     GPIOB_CRL	     =	0x40010C00
     GPIOC_CRL	     =	0x40011000
     GPIOD_CRL	     =	0x40011400
     GPIOE_CRL	     =	0x40011800
     GPIOF_CRL	     =	0x40011C00
     GPIOG_CRL	     =	0x40012000
 ; High 8 control
     GPIOA_CRH	     =	0x40010804
     GPIOB_CRH	     =	0x40010C04
     GPIOC_CRH	     =	0x40011004
     GPIOD_CRH	     =	0x40011404
     GPIOE_CRH	     =	0x40011804
     GPIOF_CRH	     =	0x40011C04
     GPIOG_CRH	     =	0x40012004
 ; 16 bit input data
     GPIOA_IDR	     =	0x40010808
     GPIOB_IDR	     =	0x40010C08
     GPIOC_IDR	     =	0x40011008
     GPIOD_IDR	     =	0x40011408
     GPIOE_IDR	     =	0x40011808
     GPIOF_IDR	     =	0x40011C08
     GPIOG_IDR	     =	0x40012008
 ; 16 bit output data
     GPIOA_ODR	     =	0x4001080C
     GPIOB_ODR	     =	0x40010C0C
     GPIOC_ODR	     =	0x4001100C
     GPIOD_ODR	     =	0x4001140C
     GPIOE_ODR	     =	0x4001180C
     GPIOF_ODR	     =	0x40011C0C
     GPIOG_ODR	     =	0x4001200C
 ; Bit set reset registers
     GPIOA_BSRR      =	0x40010810
     GPIOB_BSRR      =	0x40010C10
     GPIOC_BSRR      =	0x40011010
     GPIOD_BSRR      =	0x40011410
     GPIOE_BSRR      =	0x40011810
     GPIOF_BSRR      =	0x40011C10
     GPIOG_BSRR      =	0x40012010
 ; Bit reset registers
     GPIOA_BRR	     =	0x40010814
     GPIOB_BRR	     =	0x40010C14
     GPIOC_BRR	     =	0x40011014
     GPIOD_BRR	     =	0x40011414
     GPIOE_BRR	     =	0x40011814
     GPIOF_BRR	     =	0x40011C14
     GPIOG_BRR	     =	0x40012014
 ; Port lock registers
     GPIOA_LCKR      =	0x40010818
     GPIOB_LCKR      =	0x40010C18
     GPIOC_LCKR      =	0x40011018
     GPIOD_LCKR      =	0x40011418
     GPIOE_LCKR      =	0x40011818
     GPIOF_LCKR      =	0x40011C18
     GPIOG_LCKR      =	0x40012018
 ; Clock control
     RCC_CR		 =	0x40021000
     RCC_CFGR	     =	0x40021004
     RCC_CIR	     =	0x40021008
     RCC_APB2RSTR    =	0x4002100C
     RCC_APB1RSTR    =	0x40021010
     RCC_AHBENR      =	0x40021014
     RCC_APB2ENR     =	0x40021018
     RCC_APB1ENR     =	0x4002101C
     RCC_BDCR	     =	0x40021020
     RCC_CSR	     =	0x40021024
     RCC_AHBRSTR     =	0x40021028
     RCC_CFGR2	     =	0x4002102C
	 ;Rcc register values
	 RCC_CR_HSEON	 =  0x00010000
	 RCC_CR_HSERDY	 =  0x00020000
	 RCC_CR_PLLON	 =  0x01000000
	 RCC_CR_PLLRDY	 =  0x02000000
	 RCC_CFGR_PLLMUL3 = 0x00040000
	 RCC_CFGR_PLLMUL4 = 0x00080000
	 RCC_CFGR_PLLMUL5 = 0x000C0000
	 RCC_CFGR_PLLMUL6 = 0x00100000
	 RCC_CFGR_PLLMUL7 = 0x00140000
	 RCC_CFGR_PLLMUL8 = 0x00180000
	 RCC_CFGR_PLLMUL9 = 0x001C0000
	 RCC_CFGR_PLLSRC  = 0x00010000 ;selects prediv1 as source
	 ; prediv1 in cfg register doesn't divide clock after reset all set to zero!
	 RCC_CFGR_SW_HSI  = 0x00000000
	 RCC_CFGR_SW_HSE  = 0x00000001
	 RCC_CFGR_SW_PLL  = 0x00000002
	 RCC_CFGR_PPRE1_DIV2 = 0x00040000
	 RCC_CFGR_PPRE1_DIV4 = 0x00050000
	 RCC_CFGR_PPRE1_DIV8 = 0x00060000
	 RCC_CFGR_PPRE1_DIV16 = 0x00070000
	 RCC_CFGR_ADCPRE_DIV2 = 0x00000000
	 RCC_CFGR_ADCPRE_DIV4 = 0x00004000
	 RCC_CFGR_ADCPRE_DIV6 = 0x00008000
	 RCC_CFGR_ADCPRE_DIV8 = 0x0000C000

 ; Alternate functions
     AFIO_EVCR	     =	0x40010000
     AFIO_MAPR	     =	0x40010004
     AFIO_EXTICR1    =	0x40010008
     AFIO_EXTICR2    =	0x4001000C
     AFIO_EXTICR3    =	0x40010010
     AFIO_EXTICR4    =	0x40010014
     AFIO_MAPR2      =	0x4001001C
 ; External interrupts
     EXTI_IMR	     =	0x40010400
     EXTI_EMR	     =	0x40010404
     EXTI_RTSR	     =	0x40010408
     EXTI_FTSR	     =	0x4001040C
     EXTI_SWIER      =	0x40010410
     EXTI_PR	     =	0x40010414
 ; Analog to digital
 ; Channel1
     ADC1_SR	     =	0x40012400
     ADC1_CR1	     =	0x40012404
     ADC1_CR2	     =	0x40012408
     ADC1_SMPR1      =	0x4001240C
     ADC1_SMPR2      =	0x40012410
     ADC1_JOFR1      =	0x40012414
     ADC1_JOFR2      =	0x40012418
     ADC1_JOFR3      =	0x4001241C
     ADC1_JOFR4      =	0x40012420
     ADC1_HTR	     =	0x40012424
     ADC1_LTR	     =	0x40012428
     ADC1_SQR1	     =	0x4001242C
     ADC1_SQR2	     =	0x40012430
     ADC1_SQR3	     =	0x40012434
     ADC1_JSQR	     =	0x40012438
     ADC1_JDR1	     =	0x4001243C
     ADC1_JDR2	     =	0x40012440
     ADC1_JDR3	     =	0x40012444
     ADC1_JDR4	     =	0x40012448
     ADC1_DR	     =	0x4001244C
 ; Channel2
     ADC2_SR	     =	0x40012800
     ADC2_CR1	     =	0x40012804
     ADC2_CR2	     =	0x40012808
     ADC2_SMPR1      =	0x4001280C
     ADC2_SMPR2      =	0x40012810
     ADC2_JOFR1      =	0x40012814
     ADC2_JOFR2      =	0x40012818
     ADC2_JOFR3      =	0x4001281C
     ADC2_JOFR4      =	0x40012820
     ADC2_HTR	     =	0x40012824
     ADC2_LTR	     =	0x40012828
     ADC2_SQR1	     =	0x4001282C
     ADC2_SQR2	     =	0x40012830
     ADC2_SQR3	     =	0x40012834
     ADC2_JSQR	     =	0x40012838
     ADC2_JDR1	     =	0x4001283C
     ADC2_JDR2	     =	0x40012840
     ADC2_JDR3	     =	0x40012844
     ADC2_JDR4	     =	0x40012848
     ADC2_DR	     =	0x4001284C
 ; Channel3
     ADC3_SR	     =	0x40013C00
     ADC3_CR1	     =	0x40013C04
     ADC3_CR2	     =	0x40013C08
     ADC3_SMPR1      =	0x40013C0C
     ADC3_SMPR2      =	0x40013C10
     ADC3_JOFR1      =	0x40013C14
     ADC3_JOFR2      =	0x40013C18
     ADC3_JOFR3      =	0x40013C1C
     ADC3_JOFR4      =	0x40013C20
     ADC3_HTR	     =	0x40013C24
     ADC3_LTR	     =	0x40013C28
     ADC3_SQR1	     =	0x40013C2C
     ADC3_SQR2	     =	0x40013C30
     ADC3_SQR3	     =	0x40013C34
     ADC3_JSQR	     =	0x40013C38
     ADC3_JDR1	     =	0x40013C3C
     ADC3_JDR2	     =	0x40013C40
     ADC3_JDR3	     =	0x40013C44
     ADC3_JDR4	     =	0x40013C48
     ADC3_DR	     =	0x40013C4C
 ; Digital to analog converter
     DAC_CR	     =	0x40007400
     DAC_SWTRIGR     =	0x40007404
     DAC_DHR12R1     =	0x40007408
     DAC_DHR12L1     =	0x4000740C
     DAC_DHR8R1      =	0x40007410
     DAC_DHR12R2     =	0x40007414
     DAC_DHR12L2     =	0x40007418
     DAC_DHR8R2      =	0x4000741C
     DAC_DHR12RD     =	0x40007420
     DAC_DHR12LD     =	0x40007424
     DAC_DHR8RD      =	0x40007428
     DAC_DOR1	     =	0x4000742C
     DAC_DOR2	     =	0x40007430
 ; Timer 1
     TIM1_CR1	     =	0x40012C00
     TIM1_CR2	     =	0x40012C04
     TIM1_SMCR	     =	0x40012C08
     TIM1_DIER	     =	0x40012C0C
     TIM1_SR	     =	0x40012C10
     TIM1_EGR	     =	0x40012C14
     TIM1_CCMR1      =	0x40012C18
     TIM1_CCMR2      =	0x40012C1C
     TIM1_CCER	     =	0x40012C20
     TIM1_CNT	     =	0x40012C24
     TIM1_PSC	     =	0x40012C28
     TIM1_ARR	     =	0x40012C2C
     TIM1_RCR	     =	0x40012C30
     TIM1_CCR1	     =	0x40012C34
     TIM1_CCR2	     =	0x40012C38
     TIM1_CCR3	     =	0x40012C3C
     TIM1_CCR4	     =	0x40012C40
     TIM1_BDTR	     =	0x40012C44
     TIM1_DCR	     =	0x40012C48
     TIM1_DMAR	     =	0x40012C4C
	 ;Timer1 register values
	 TIM1_CR1_ARPE		= 0x0080
	 TIM1_CR1_CMS_E 	= 0x0000
	 TIM1_CR1_CMS_C1	= 0x0020
	 TIM1_CR1_CMS_C2	= 0x0040
	 TIM1_CR1_CMS_C3	= 0x0060
	 TIM1_CR1_DIR_D 	= 0x0010
	 TIM1_CR1_OPM		= 0x0008
	 TIM1_CR1_URS_ALL	= 0x0000
	 TIM1_CR1_URS_UO	= 0x0004
	 TIM1_CR1_UDIS		= 0x0002
	 TIM1_CR1_CEN		= 0x0001
	 TIM1_CR2_CCDS_U	= 0x0008
	 TIM1_DIER_TDE		= 0x4000 ;trigger dma request enabled
	 TIM1_DIER_UDE		= 0x0100 ;update dma request enabled
	 TIM1_DIER_UIE		= 0x0001 ;update interrupt enabled


; Timer 2
	 TIM2_CR1		 =  0x40000000
	 TIM2_CR2		 =  0x40000004
	 TIM2_SMCR		 =  0x40000008
	 TIM2_DIER		 =  0x4000000C
	 TIM2_SR		 =  0x40000010
	 TIM2_EGR		 =  0x40000014
	 TIM2_CCMR1		 =  0x40000018
	 TIM2_CCMR2		 =  0x4000001C
	 TIM2_CCER		 =  0x40000020
	 TIM2_CNT		 =  0x40000024
	 TIM2_PSC		 =  0x40000028			
	 TIM2_ARR		 =  0x4000002C
	 
	 TIM2_CCR1		 =  0x40000034
	 TIM2_CCR2		 =  0x40000038
	 TIM2_CCR3		 =  0x4000003C
	 TIM2_CCR4		 =  0x40000040
	 
	 TIM2_DCR		 =  0x40000048
	 TIM2_DMAR		 =  0x4000004C
; Timer 3
	 TIM3_CR1		 =  0x40000400
	 TIM3_CR2		 =  0x40000404
	 TIM3_SMCR		 =  0x40000408
	 TIM3_DIER		 =  0x4000040C
	 TIM3_SR		 =  0x40000410
	 TIM3_EGR		 =  0x40000414
	 TIM3_CCMR1		 =  0x40000418
	 TIM3_CCMR2		 =  0x4000041C
	 TIM3_CCER		 =  0x40000420
	 TIM3_CNT		 =  0x40000424
	 TIM3_PSC		 =  0x40000428			
	 TIM3_ARR		 =  0x4000042C
	 
	 TIM3_CCR1		 =  0x40000434
	 TIM3_CCR2		 =  0x40000438
	 TIM3_CCR3		 =  0x4000043C
	 TIM3_CCR4		 =  0x40000440
	 
	 TIM3_DCR		 =  0x40000448
	 TIM3_DMAR		 =  0x4000044C
; Timer 4
	 TIM4_CR1		 =  0x40000800
	 TIM4_CR2		 =  0x40000804
	 TIM4_SMCR		 =  0x40000808
	 TIM4_DIER		 =  0x4000080C
	 TIM4_SR		 =  0x40000810
	 TIM4_EGR		 =  0x40000814
	 TIM4_CCMR1		 =  0x40000818
	 TIM4_CCMR2		 =  0x4000081C
	 TIM4_CCER		 =  0x40000820
	 TIM4_CNT		 =  0x40000824
	 TIM4_PSC		 =  0x40000828			
	 TIM4_ARR		 =  0x4000082C
	 
	 TIM4_CCR1		 =  0x40000834
	 TIM4_CCR2		 =  0x40000838
	 TIM4_CCR3		 =  0x4000083C
	 TIM4_CCR4		 =  0x40000840
	 
	 TIM4_DCR		 =  0x40000848
	 TIM4_DMAR		 =  0x4000084C	 
 ; Flash interface
     FLASH_ACR		=  0x40022000
     FLASH_KEYR     =  0x40022004
     FLASH_OPTKEYR  =  0x40022008
     FLASH_SR		=  0x4002200C
     FLASH_CR		=  0x40022010
     FLASH_AR		=  0x40022014
     FLASH_OBR		=  0x4002201C
     FLASH_WRPR     =  0x40022020
	    ;Flash register values
	    FLASH_ACR_LATENCY_0 = 0x00000000
	    FLASH_ACR_LATENCY_1 = 0x00000001
	    FLASH_ACR_LATENCY_2 = 0x00000002
	  


